/*
 * Copyright IBM Corp. and others 1991
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 */

/**
 * WARNING!!! GENERATED FILE
 *
 * This class is generated.
 * Do not use the Eclipse "Organize Imports" feature on this class.
 *
 * It can contain user content, but that content must be delimited with the
 * the tags
 * [BEGIN USER IMPORTS]
 * [END USER IMPORTS]
 *
 * or
 *
 * [BEGIN USER CODE]
 * [END USER CODE]
 *
 * These tags are entered as comments.  Characters before [ and after ] are ignored.
 * Lines between the tags are inserted into the newly generated file.
 *
 * IMPORTS are combined and inserted above newly generated imports.  CODE is combined
 * and inserted immediately after the class declaration
 *
 * All lines outside these tags are lost and replaced with newly generated code.
 */
package com.ibm.j9ddr.vm29.pointer.generated;

/*[BEGIN USER IMPORTS]*/
/*[END USER IMPORTS]*/

import com.ibm.j9ddr.CorruptDataException;
import com.ibm.j9ddr.vm29.pointer.*;
import com.ibm.j9ddr.vm29.structure.*;
import com.ibm.j9ddr.vm29.types.*;

/**
 * Structure: _PMDPointer
 *
 * A generated implementation of a VM structure
 *
 * This class contains generated code and MAY contain hand written user code.
 *
 * Hand written user code must be contained at the top of
 * the class file, specifically above
 * the comment line containing WARNING!!! GENERATED CODE
 *
 * ALL code below the GENERATED warning will be replaced with new generated code
 * each time the PointerGenerator utility is run.
 *
 * The generated code will provide getters for all elements in the _PMDPointer
 * structure.  Where possible, meaningful return types are inferred.
 *
 * The user may add methods to provide meaningful return types where only pointers
 * could be automatically inferred.
 */
@com.ibm.j9ddr.GeneratedPointerClass(structureClass=_PMD.class)
public class _PMDPointer extends StructurePointer {

	// NULL
	public static final _PMDPointer NULL = new _PMDPointer(0);

/*[BEGIN USER CODE]*/
/*[END USER CODE]*/

	// Do not call this constructor.  Use static method cast instead.
	protected _PMDPointer(long address) {
		super(address);
	}

	public static _PMDPointer cast(AbstractPointer structure) {
		return cast(structure.getAddress());
	}

	public static _PMDPointer cast(UDATA udata) {
		return cast(udata.longValue());
	}

	public static _PMDPointer cast(long address) {
		if (address == 0) {
			return NULL;
		}
		return new _PMDPointer(address);
	}

	public _PMDPointer add(long count) {
		return _PMDPointer.cast(address + (_PMD.SIZEOF * count));
	}

	public _PMDPointer add(Scalar count) {
		return add(count.longValue());
	}

	public _PMDPointer addOffset(long offset) {
		return _PMDPointer.cast(address + offset);
	}

	public _PMDPointer addOffset(Scalar offset) {
		return addOffset(offset.longValue());
	}

	public _PMDPointer sub(long count) {
		return _PMDPointer.cast(address - (_PMD.SIZEOF * count));
	}

	public _PMDPointer sub(Scalar count) {
		return sub(count.longValue());
	}

	public _PMDPointer subOffset(long offset) {
		return _PMDPointer.cast(address - offset);
	}

	public _PMDPointer subOffset(Scalar offset) {
		return subOffset(offset.longValue());
	}

	public _PMDPointer untag(long mask) {
		return _PMDPointer.cast(address & ~mask);
	}

	public _PMDPointer untag() {
		return untag(UDATA.SIZEOF - 1);
	}

	protected long sizeOfBaseType() {
		return _PMD.SIZEOF;
	}

	// Implementation methods

	// I32 mdisp
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_mdispOffset_", declaredType="I32")
	public IDATA mdisp() throws CorruptDataException {
		return new I32(getIntAtOffset(_PMD._mdispOffset_));
	}

	// I32 mdisp
	public IDATAPointer mdispEA() throws CorruptDataException {
		return IDATAPointer.cast(nonNullFieldEA(_PMD._mdispOffset_));
	}

	// I32 pdisp
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_pdispOffset_", declaredType="I32")
	public IDATA pdisp() throws CorruptDataException {
		return new I32(getIntAtOffset(_PMD._pdispOffset_));
	}

	// I32 pdisp
	public IDATAPointer pdispEA() throws CorruptDataException {
		return IDATAPointer.cast(nonNullFieldEA(_PMD._pdispOffset_));
	}

	// I32 vdisp
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_vdispOffset_", declaredType="I32")
	public IDATA vdisp() throws CorruptDataException {
		return new I32(getIntAtOffset(_PMD._vdispOffset_));
	}

	// I32 vdisp
	public IDATAPointer vdispEA() throws CorruptDataException {
		return IDATAPointer.cast(nonNullFieldEA(_PMD._vdispOffset_));
	}

}
